--------------------------------------------------------------------------------
# Deep Thinking
### Wrappers for easily implementing deep thinking networks.

## Deep Thinking Networks
Introduced by [Schwarzschild *et al.* (2021)](https://arxiv.org/abs/2106.04537)
with follow-up work by
[Bansal *et al.* (2022)](https://arxiv.org/abs/2202.05826), deep thinking (DT)
networks are a type of recurrent architecture that has been shown to generalize
well to logical tasks that can involve extrapolation.
### Generalization
These models can be generalized by identifying key interchangeable components
called "modules", such as the *preprocessing module*, the *thought module*,
and the *output module*.

As such, these are wrappers which allow the user to define their own modules
without having to build the overall deep thinking structure.
